import { LastUpdateInfo } from "./last-update-info";
export interface BaseProps {
    id: string;
    lastUpdateDate: Date;
    lastUpdateInfo?: LastUpdateInfo;
}
export declare abstract class Entity<T extends BaseProps> {
    private readonly _id;
    private _lastUpdateDate;
    private _lastUpdateInfo?;
    constructor(entity: T);
    get id(): string;
    get lastUpdateDate(): Date;
    set lastUpdateDate(lastUpdateDate: Date);
    get lastUpdateInfo(): LastUpdateInfo;
    set lastUpdateInfo(lastUpdateInfo: LastUpdateInfo);
    abstract toObject(): unknown;
}
